\documentclass[12pt]{report}

\newcommand\lessontitle{Lecture 2 -- OS Installation}
\newcommand\lessondate{February 11, 2021}

\usepackage[a4paper, landscape, margin=2cm]{geometry}
\usepackage{fontspec}
\usepackage{microtype}
\usepackage{fancyhdr}
\usepackage{sectsty}
\usepackage{hyperref}

\setmainfont{Calluna-Regular.otf}[
  BoldFont = Calluna-Bold.otf ]
\setsansfont{MuseoSans-500.otf}[
  BoldFont = MuseoSans-900.otf,
  ItalicFont = MuseoSans-500Italic.otf ]

\pagestyle{fancy}
\fancyhf{}
\renewcommand{\headrulewidth}{0.5pt}
\renewcommand{\footrulewidth}{0.5pt}
\lhead{\textsf{Operation of IT Systems -- ENPTIA2401-PRACT}}
\rhead{\textsf{\lessontitle}}
\rfoot{\textsf{Page \thepage}}
\lfoot{\textsf{\lessondate}}

\setcounter{secnumdepth}{0}

\setlength{\parindent}{0pt}

\sectionfont{\clearpage\Huge\sffamily}
\subsectionfont{\sffamily}

\hypersetup{
    colorlinks=true,
    linkcolor=black,
    urlcolor=black,
}
\urlstyle{same}


\begin{document}

\begin{titlepage}
{\Huge \bfseries \textsf{Operation of IT Systems -- ENPTIA2401-PRACT} \par}
\vspace{1cm}
{\Large \bfseries \textsf{\lessontitle} \par}
\vspace{1cm}
{\Large \textsf{\lessondate} \par}
\vfill
{\large \textsf{András Kalmár-Nagy (\href{mailto:andras.kalmar-nagy@t-systems.com}{andras.kalmar-nagy@t-systems.com})}}
\end{titlepage}

\section{Getting an Operating System}

How you come by an operating system differs depending on the model preferred by the vendor.\\

Proprietary OSes, like OS X, Windows and most mobile OSes, either come pre-installed on the hardware, or you can purchase physical installation media.\\

Open source OSes, like BSD and Linux, can be donwloaded and copied to media.

\subsection{Choosing the Right Architecture}

Processors in hardware conform to architectures. An architecture defines what instructions a processor can carry out. If an OS is built for a specific architecture, it will not work on a different architecture. Usually processor architectures are divided according to how large their internal memory registers are. There are 32bit and 64bit architectures. 32 bit systems can only use around 4Gb of RAM, for 64bit systems, this limit is much larger. 32bit OSes can work on 64bit systems, but will most likely be limited in how much of the capacity of the machine they can access.\\

Common architectures include \texttt{i386/x86, x86\_64/amd64, armhfp/arm32, aarch64/arm64, ppc64le/ppc64}.\\

Modern processors will mostly be either \texttt{amd64} or \texttt{arm64}.

\subsection{Choosing the Right Edition}

Some OSes have editions based on the role the OS will be used for.\\

Windows 10 has several editions: Home, Pro, Pro Education, Education, Pro for Workstations and Enterprise. These differ in the intended audience, and the features provided.\\

Linux Distributions usually have several desktop editions based on different window managers, and server and minimal editions. For example, you can get Ubuntu with it's default desktop environment, but you can also get it with XFCE or KDE. There are also server editions which don't contain any graphical interfaces. And minimal installation images, where only a very basic set of packages are included.

\clearpage
\section{\Huge \textsf{Preparing the Hardware for Installation}}

If the hardware is not pre-installed with the OS, there are a few steps, that may be necessary to prepare it for the installation:
\begin{itemize}
\item You need to make sure that you can boot off the device that contains your installation media.
\item Some BIOSes will only accept signed installation media, this may need to be disabled.
\item You need to prepare network access credentials or a physical cable to be able to download packages
\end{itemize}

\clearpage
\section{Starting the installation}

With most installers, you will need to press a key when prompted, to start the installation.\\

Modern installers are very user friendly and usually consist of a series of questions. The following information is usually needed for an installation:
\begin{itemize}
\item What language the installation should take place in.
\item Where you are in the world. This is used to set timezone and locale information, like units of currency and date/time formats.
\item What keyboard layout you would like to use.
\item Network access credentials. This is used to set up your network address and download additional functionality or updates during the installation.
\item You will be asked to enter a product key, if you are using proprietary software.
\item You will be asked about partitioning storage for the OS. Most installers have a default setting which is usually correct for a machine that is being installed for the first time. Advanced options let you determine the partitioning and filesystem types used.
\item You may also be offered the option of selecting components to install based on the task the computer is intended for.
\item Finally, an administrative user is created to grant access to the new system.
\end{itemize}

After this, drivers for the hardware, packages and executables for the OS are copied to the machine, the bootloader is loaded into the Master Boot Record (MBR), and the OS is set up according to your choices.

\clearpage
\section{The First Boot}

After the end of the installation, the machine is usually restarted, so that the OS can boot for the first time.\\

The example I use is Linux, but OS X and Windows are similar. The boot process entails the folowing steps:
\begin{enumerate}
\item The BIOS initializes the hardware components.
\item The BIOS checks for an MBR on the devices in the boot list.
\item If an MBR is found, the bootloader (called GRUB, under modern distros) in the record is executed. Under Linux, this lets one choose the kernel to be loaded, or an emergency console can be started.
\item The bootloader then loads the kernel, which mounts the root filesystem, and executes the init process. (This is either \texttt{init} or \texttt{systemd})
\item The init process than starts all system services and finally a shell, for the user to log into.
\end{enumerate}

\clearpage
\section{The first steps in a new OS}

If everything went smoothly, you are greeted by your new OS.\\

From here on, you can install additional software, create users, set up services and start using your machine.\\

In enterprise environments, your data may be stored on a network drive, and this may be used to load an already familiar environment. The new machine may be used to access remote environments, in which case only a few client programs are installed on the machine.

\clearpage
\section{Virtual and Embedded OS Installation}

Virtual and embedded machines are usually started from a preset image, that already contains a preconfigured OS.\\

Instead of using a generic installer, that is suited for a variety of machines and tasks, images are built for specific hardware and a set task. The image is either copied to the memory of the embedded system, or started by the hypervisor of the virtual platform. The image already contains preconfigured values for the OS settings, and may also contain a specific application that is started on boot. Some virtual machines are made in a way that they are never accessed by a human user, insted thay are managed by an orchestration system that starts and stops tham automatically.\\

There are various tools that can be used to create these machine images, so that they can be custom built for specific tasks. Virtual machines can be customised to a degree upon startup, to configure network settings and choose packages or configuration scripts that are started after boot. One such system is called \texttt{cloud-init}.

\clearpage
\section{Useful Links}

\begin{itemize}
\item \href{https://ubuntu.com/download/desktop}{Ubuntu Desktop edition download page}
\item \href{https://ubuntu.com/tutorials/install-ubuntu-desktop#1-overview}{Ubuntu Desktop install guide}
\item \href{https://ubuntu.com/tutorials/install-ubuntu-server#1-overview}{Ubuntu Server install guide}
\item \href{https://www.virtualbox.org/wiki/Downloads}{Virtualbox download page}
\end{itemize}

\section{Glossary}
\begin{itemize}
  \item \textbf{Booting (Bootstrapping)} -- The process of starting a computer.
  \item \textbf{Bootloader} -- Special software that loads the kernel of the operating system into memory.
  \item \textbf{Master Boot Record (MBR)} -- A special part of a storage device that contains the bootloader.    
  \item \textbf{BIOS} -- Basic Input Output System. A low-level part of the system that initialises hardware, does the power-on self-test, and starts the bootloader for the OS.
  \item \textbf{OS Installer} -- A specialised program that prepares and copies the operating system onto a blank machine.
  \item \textbf{Virtual Machine} -- Virtual machines are a technology to enable a host computer to simulate another computer. Large servers can run many such virtual machines at once. They enable isolation of resources, and give flexibility in managing large resource pools.
\end{itemize}

\section{Exam Questions}
\begin{itemize}
  \item \textbf{Can you install a 32bit OS on a 64bit architecture?} -- Yes, however, some hardware capacity may be unaccessable to a 32bit OS (eg.: 32bit OSes only support ~4Gb RAM). You cannot install a 64bit OS on a 32bit system.
  \item \textbf{If your computer already han an OS, can you install a different one on it?} -- Yes, and some OSes can even be installed side-by-side, and you can choose at boot time. Care must however be taken, so that valuable data isn't deleted by the new OS install.
  \item \textbf{Can a virtual machine have more RAM and CPU than the host system?} -- No, virtual machines share the resources of the host system, and cannot have more than the machine that they are running on. This is also true, even if the virtual machine hosts are in a cluster.
  \item \textbf{Do you need special media to install an operating system?} -- No, any commercially available CD/DVD or USB-drive can be turned into an OS installer media by copying the appropriate files to it. However, for proprietary OSes, this may be prohibited under copyright laws.
\end{itemize}

\end{document}